Bug 259640 - Deleted windows not unrefed when restarting compositing
Summary: Deleted windows not unrefed when restarting compositing
Status: RESOLVED FIXED
Alias: None
Product: kwin
Classification: Unclassified
Component: compositing (show other bugs)
Version: unspecified
Platform: Gentoo Packages Linux
: NOR normal with 3 votes (vote)
Target Milestone: 4.10.2
Assignee: KWin default assignee
URL: https://git.reviewboard.kde.org/r/109...
Keywords:
: 300545 308074 311296 319413 (view as bug list)
Depends on:
Blocks:
 
Reported: 2010-12-12 20:31 UTC by Krzysztof Nowicki
Modified: 2013-05-06 15:00 UTC (History)
11 users (show)

See Also:
Latest Commit:
Version Fixed In: 4.10.2
thomas.luebking: ReviewRequest+


Attachments
kwinrc (6.25 KB, application/octet-stream)
2010-12-18 18:25 UTC, Krzysztof Nowicki
Details
A screenshot of the bug (61.27 KB, image/jpeg)
2012-04-03 21:05 UTC, Kyrylo Bohdanenko
Details
Output of "qdbus org.kde.kwin /KWin supportInformation" (5.73 KB, text/plain)
2012-12-07 14:01 UTC, David de Cos
Details
Another screenshot showing bug (1.15 MB, image/png)
2013-03-08 03:29 UTC, Bartłomiej Burdukiewicz
Details
qdbus org.kde.kwin /KWin supportInformation (4.62 KB, text/plain)
2013-03-08 03:42 UTC, Bartłomiej Burdukiewicz
Details
Ghost window (347.43 KB, image/png)
2013-03-09 01:17 UTC, Bartłomiej Burdukiewicz
Details
Ghost buttons (664.49 KB, image/png)
2013-03-09 03:47 UTC, Bartłomiej Burdukiewicz
Details
Patch attempt (1.86 KB, patch)
2013-03-10 00:37 UTC, Thomas Lübking
Details
Patch attempt #2 (2.10 KB, patch)
2013-03-10 07:00 UTC, Thomas Lübking
Details
One more shot (3.06 KB, patch)
2013-03-11 22:24 UTC, Thomas Lübking
Details
Screenshot showing the bug (784.35 KB, image/png)
2013-03-14 21:50 UTC, Sebastian Zientek
Details
Configuration of KWin (4.10.1) (3.48 KB, text/plain)
2013-03-14 22:28 UTC, Bartłomiej Burdukiewicz
Details
Toodeloo... (3.54 KB, patch)
2013-03-15 16:29 UTC, Thomas Lübking
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Krzysztof Nowicki 2010-12-12 20:31:01 UTC
Version:           unspecified (using KDE 4.5.85) 
OS:                Linux

I noticed that in KDE 4.6 the "present windows" was enhanced to allow closing windows while the windows are presented. Close buttons appear when holding the mouse over a window for a few seconds. I like this feature - it's quite useful.

Unfortunately when switching the desktops using the desktop cube effect I see all the close buttons showing during the transition. They however disappear once the transition is complete.

I have the "Use pager layout for animation" option activated.

The buttons also appear when the "Start animation when moving windows towards screen edges" effect has been enabled and a window is moved close to the screen edge.



Reproducible: Always

Steps to Reproduce:
1. Activate desktop switching using desktop cube.
2. Activate "Use pager layout for animation" option in desktop cube settings.
3. (optional) Activate "Start animation when moving windows towards screen edges" option in desktop cube settings.
4. Switch the active desktop.

Actual Results:  
A number of buttons with a red close icon appear overlaid on the screen while the desktop cube is flipping desktops.

Expected Results:  
No buttons should appear.
Comment 1 Martin Flöser 2010-12-12 20:38:29 UTC
I knew we somewhere leak these deleted windows, but was never able to 
reproduce it reliable. Thanks for the nice hint on how to reproduce it :-)
Comment 2 Martin Flöser 2010-12-18 11:33:40 UTC
sorry I am not able to reproduce on two different systems
Comment 3 Krzysztof Nowicki 2010-12-18 12:44:00 UTC
Maybe the contents of my kwinrc would be helpful?
Comment 4 Thomas Lübking 2010-12-18 15:57:31 UTC
maybe, just attach it (doesn't happen here either)
Comment 5 Krzysztof Nowicki 2010-12-18 18:25:13 UTC
Created attachment 55054 [details]
kwinrc

My kwinrc config file.
Comment 6 Krzysztof Nowicki 2010-12-18 18:30:35 UTC
BTW, I've just tried with a fresh kwinrc and the problem is gone.
Comment 7 Thomas Lübking 2010-12-18 18:50:35 UTC
Nope, still doesn't happen here.

I wonder how it should at all since there's a delay before the buttons show up and you use "fast" animations... :-\

Can you recreate the issue on your by "fixing" the fresh kwinrc (towards your former settings) and this way determine the culprit?
Comment 8 Krzysztof Nowicki 2010-12-18 19:01:32 UTC
I've just tried that. The strange thing is that now I'm back to my old kwinrc and the problem still doesn't appear.

Something else must have changed. Silly me - I could make a full snapshot of the files.
Comment 9 Martin Flöser 2010-12-18 19:12:07 UTC
I have a way to reproduce (sometimes) a similar issue by changing some 
settings in desktop effects module and closing. It's important that 
compositing gets restarted.

When the bug occurs I can see the ghost compositing module on desktop switch 
with cube animation.

I assume that a window is referrencing the deleted window and when compositing 
restarts it will not be unreffed and by that never removed.
Comment 10 Krzysztof Nowicki 2010-12-18 19:20:24 UTC
Yes, I see that one sometimes as well. Not happened to me for a long while though.

I frequently however see another one - when switching the desktops with the desktop cube, the pager overlay doesn't dissappear from the screen. Doing another desktop switch fixes the problem. It happened quite frequently a while ago (I think that was in early 4.5.x versions), but nowdays I don't see it very often.
Comment 11 Krzysztof Nowicki 2010-12-20 10:19:53 UTC
Just an update: After some time (unfortunately I didn't pay attention, so I can't tell exactly) the problem reappeared yesterday with the old kwinrc. The system wasn't restarted in the meantime.
Comment 12 Rodney Gedda 2011-06-11 04:19:41 UTC
I can confirm this also happens to me with kde 4.6.3 on Chakra. Suspending and resuming compositing clears the close buttons, but the "show windows" hot corner brings the close button back when you click on that window to show it. Is that the reproduce case? Can someone else try this:

- Use hot corner to show windows
- hover over a window with mouse until "close" button appears.
- click on that Window to bring it to front 
- The close button where that window was will now appear when spinning the cube
- repeat with other windows to get more close buttons appearing

Hope that helps.
Comment 13 Thomas Lübking 2011-06-11 13:49:38 UTC
this patch might implicitly fix this issue:
https://git.reviewboard.kde.org/r/101318/
Comment 14 Octavian Petre 2011-09-14 13:51:16 UTC
Still there in kde 4.7.1
Comment 15 Martin Flöser 2011-11-01 05:50:04 UTC
Git commit 43b90f4ffc53fbd756481baa3f5965ca9aff7571 by Martin Gräßlin.
Committed on 01/11/2011 at 06:48.
Pushed by graesslin into branch 'master'.

Don't handle closing windows while BoxSwitch is inactive

This might be the cause for ghost windows, because they got
referrenced without being unreferrenced again.
CCBUG: 259640

M  +3    -0    kwin/effects/boxswitch/boxswitch.cpp

http://commits.kde.org/kde-workspace/43b90f4ffc53fbd756481baa3f5965ca9aff7571
Comment 16 Martin Flöser 2011-11-01 05:51:28 UTC
Git commit d81409f39a09057f592c0a3b01df995fc68c2af0 by Martin Gräßlin.
Committed on 01/11/2011 at 06:48.
Pushed by graesslin into branch 'KDE/4.7'.

Don't handle closing windows while BoxSwitch is inactive

This might be the cause for ghost windows, because they got
referrenced without being unreferrenced again.
CCBUG: 259640

M  +3    -0    kwin/effects/boxswitch/boxswitch.cpp

http://commits.kde.org/kde-workspace/d81409f39a09057f592c0a3b01df995fc68c2af0
Comment 17 Jure Repinc 2012-01-09 17:58:11 UTC
Ghost windows are fixed but I still get ghost close buttons. This is on a few days old code from Git for KDE 4.8.And it looks like the close buttons are multiplying over time. Even if all the windows are close.
Comment 18 Krzysztof Nowicki 2012-01-09 18:19:00 UTC
Same here - ghost close buttons still appear on KDE 4.8 RC2.
Comment 19 Thomas Lübking 2012-01-09 18:34:43 UTC
Could you both please post the output of:
grep -iE 'kwin4_effect_.*Enabled=true' `kde4-config --path config | cut -d":" -f1`/kwinrc | sed -e 's/kwin4_effect_//g; s/Enabled=true//g'
Comment 20 Jure Repinc 2012-02-21 11:24:39 UTC
blur
coverswitch
cubeslide
dashboard
desktopgrid
dialogparent
diminactive
dimscreen
fade
highlightwindow
login
logout
maketransparent
minimizeanimation
outline
presentwindows
screenshot
slidingpopups
startupfeedback
translucency
Comment 21 Jure Repinc 2012-02-21 11:28:26 UTC
Another thing I noticed is how now when I switched to plasma-netbook interface and then back to normal desktop interface now in addition to close buttons I also get the whole Plasma Netbook Launcher "screenshot" in the background of those close buttons.
Comment 22 Krzysztof Nowicki 2012-02-21 16:47:05 UTC
Here's my list:

blur
boxswitch
coverswitch
cubeslide
dashboard
dialogparent
dimscreen
fade
flipswitch
glide
login
logout
maketransparent
minimizeanimation
presentwindows
screenshot
slidingpopups
startupfeedback
taskbarthumbnail
trackmouse
translucency
wobblywindows
zoom
Comment 23 Kyrylo Bohdanenko 2012-04-03 21:05:17 UTC
Created attachment 70126 [details]
A screenshot of the bug

Also affects me (kde 4.8.1). Effects:

blur
boxswitch
coverswitch
cube
cubeslide
dashboard
desktopgrid
dialogparent
fade
glide
highlightwindow
login
logout
magiclamp
minimizeanimation
outline
presentwindows
screenshot
slideback
slidingpopups
startupfeedback
taskbarthumbnail
translucency
zoom
Comment 24 Thomas Lübking 2012-04-10 00:54:32 UTC
- does anybody encountering this bug NOT have either the boxswitch effect enabled or the -sidearm boxswitch in coverswitch enabled?
- does the issue remain when deactivating the fade effect?
Comment 25 Kyrylo Bohdanenko 2012-04-16 23:02:37 UTC
(In reply to comment #24)
> - does anybody encountering this bug NOT have either the boxswitch effect
> enabled or the -sidearm boxswitch in coverswitch enabled?
> - does the issue remain when deactivating the fade effect?

The issue remains when deactivating fade effect.
Also the issue shows only with boxswitch turned on. Futhermore, it remains even when turning boxswitch on and off.
Comment 26 Martin Flöser 2012-05-24 10:37:58 UTC
*** Bug 300545 has been marked as a duplicate of this bug. ***
Comment 27 Martin Flöser 2012-05-24 10:40:43 UTC
This issue is hopefully resolved in current master. It would be nice if someone could confirm once the beta for 4.9 is released.
Comment 28 Thomas Lübking 2012-12-07 13:21:33 UTC
*** Bug 311296 has been marked as a duplicate of this bug. ***
Comment 29 David de Cos 2012-12-07 14:00:05 UTC
I just reported Bug 311296 (duplicate), so it's still present in 4.9.4. I can't always reproduce the bug using some of the methods reported in this conversation; I can, however, always reproduce it if I have exactly two windows and close one of them in Present Windows.
(Check http://dl.dropbox.com/u/49436584/bug_cube_rotation.avi)

I'm attaching the output of "qdbus org.kde.kwin /KWin supportInformation" by request of Thomas Lübking.
Comment 30 David de Cos 2012-12-07 14:01:18 UTC
Created attachment 75680 [details]
Output of "qdbus org.kde.kwin /KWin supportInformation"
Comment 31 Martin Flöser 2012-12-29 09:18:48 UTC
*** Bug 308074 has been marked as a duplicate of this bug. ***
Comment 32 Bartłomiej Burdukiewicz 2013-03-08 03:29:22 UTC
Created attachment 77846 [details]
Another screenshot showing bug

Bug is still present in 4.10.1.

Linux navi 3.8.2-gentoo #5 SMP PREEMPT Fri Mar 8 04:18:49 CET 2013 x86_64 AMD Phenom(tm) II X4 965 Processor AuthenticAMD GNU/Linux

My box CFLAGS and CXXFLAGS
CFLAGS="-pipe -mtune=native -march=native -O2"
CXXFLAGS="-pipe -mtune=native -march=native -O2"
Comment 33 Bartłomiej Burdukiewicz 2013-03-08 03:42:53 UTC
Created attachment 77847 [details]
qdbus org.kde.kwin /KWin supportInformation

Also qdbus org.kde.kwin /KWin supportInformation output
Comment 34 Thomas Lübking 2013-03-08 20:26:37 UTC
remaining commons:
-------------------------
kwin4_effect_login
kwin4_effect_slidingpopups
kwin4_effect_minimizeanimation
kwin4_effect_translucency
kwin4_effect_cubeslide
kwin4_effect_screenshot
kwin4_effect_fade
kwin4_effect_dialogparent
kwin4_effect_presentwindows
kwin4_effect_logout
kwin4_effect_startupfeedback

"fade" has seen a complete replacement in 4.10 - so we can probably rule it out as well.

References are hold by:
// boxswitch
// coverswitch
// desktopgrid
// explosion
// fallapart
// glide
presentwindows
// sheet
slidingpopups
// snaphelper
// wobblywindows

So it will be either slidingpopups or presentwindows itself which "forget" to unreference the window.
-> Please see whether the issue is reproducibly w/o "sliding popup" (run "kcmshell4 kwincompositing", 2nd tab)

Other than that void PresentWindowsEffect::slotWindowClosed() looks übersuspicious:

...
    winData->deleted = true;
    winData->referenced = true;
    w->refWindow();
...
    if (m_closeWindow == w) {
        m_closeWindow = 0;
        return; // don't rearrange
    }

obviously the m_closeWindow can get referenced? Should rather not happen, should it?
At least it won't be unreferenced (as not rearranged()) - and why would it be in m_windowData.

==> Anyone can try a patch?
Comment 35 Bartłomiej Burdukiewicz 2013-03-09 01:17:21 UTC
Created attachment 77878 [details]
Ghost window

(In reply to comment #29)
> I can, however, always reproduce it if I have exactly two
> windows and close one of them in Present Windows.

Can't reproduce that, but when I kill all windows by present windows effect, the ghost window appears.
Comment 36 Bartłomiej Burdukiewicz 2013-03-09 01:33:58 UTC
Notice: Always the last window that is closed appear as ghost. 

Order: closing A, closing B, closing: C. 
C will appear as ghost
Comment 37 Bartłomiej Burdukiewicz 2013-03-09 03:33:02 UTC
I find the way to reproduce close button ghost.

1) Empty session without any windows around (start new empty kde session)
2) Open window (i.e dolphin)
3) Minimize window (I'm using Minimize window and Fade effect)
4) Trigger "Present Window - All desktops" using screen edge
5) Cube Animation should be affected now!

Additional condition note:
1) I do not use any taskbar plasmoid
2) I'm using yakuake, but yakuake window remain hidden all the time
3) I'm using Current Application Control plasmoid
4) I'm using Caledonia as plasma theme
5) I attached kwin support output before
Comment 38 Bartłomiej Burdukiewicz 2013-03-09 03:47:47 UTC
Created attachment 77879 [details]
Ghost buttons

I repeated steps many times (excluding first). Each time there is another new button ghost.
Comment 39 Krzysztof Nowicki 2013-03-09 07:36:59 UTC
(In reply to comment #34)

> -> Please see whether the issue is reproducibly w/o "sliding popup" (run
> "kcmshell4 kwincompositing", 2nd tab)

Reproduced with sliding popup effect disabled.

The method I used this time:
 1. Open two windows (in my case Konsole and Dolphin). Both windows are on one desktop.
 2. In Konsole restart KWin (kwin --replace). Konsole will remain the active window.
 3. Trigger Present all windows on all desktops.
 4. Point the Dolphin window and click to activate it.
 5. From now on the close button that appeared over the Dolphin window will show when changing desktops using the cube animation.
Comment 40 Thomas Lübking 2013-03-09 17:18:03 UTC
The bug is somewhere in Presentwindows.

I still cannot reproduce it, but the windows are unreferenced in prePaintWindow if either the effect is active or the motionmanager contains the window.

The motionmanager contains windows which are either present in the stacking order on start or which get added and are "selectable" (ie. regular windows, what the closeview is not)

The closewindow gets referenced when it's closed (for the fade-out) so there is clearly the option for a race condition (closed & referenced on deactivation and no motion, resp. reaches zero opacity "too late")

Anybody able to

a) reproduce this at will
b) compile a patched kwin

please raise hands - i want to ensure this is the cause.
Comment 41 Bartłomiej Burdukiewicz 2013-03-10 00:27:57 UTC
Count me in, where can I find these patches?
Comment 42 Thomas Lübking 2013-03-10 00:37:04 UTC
Created attachment 77898 [details]
Patch attempt

Attached, thanks alot.
Comment 43 Bartłomiej Burdukiewicz 2013-03-10 01:14:48 UTC
Bug is still present, even with patch, but I also compile kwin with additional debug, and I got this when ghost wnd appears. For ghost close button case I get same message. 

kwin(29328) KWin::x11ErrorHandler: kwin: X Error ( "error: BadDamage [DAMAGE+0], request: XDamageDestroy[DAMAGE+2], resource: 0x18011e8" )
Comment 44 Thomas Lübking 2013-03-10 07:00:00 UTC
Created attachment 77907 [details]
Patch attempt #2

Do not fear, there's still hope.
This one would also catch the second race (double close)
Comment 45 Bartłomiej Burdukiewicz 2013-03-11 21:45:52 UTC
Nah, bug still present. I'm not afraid of compilation and etc. If you have some fancy debugging code that would be great, I really want to track down this problem. 

About this race condition, isn't that strange that bug appears 100% of the time?
Comment 46 Thomas Lübking 2013-03-11 22:24:40 UTC
Created attachment 77970 [details]
One more shot

One shot left.
Please check whether you can actually trigger this with nothing but PW and DG enabled.

If yes and this doesn't catch it, i'll add a refcounter property to the windows and a nice assert >-)
Comment 47 Cezar "ikari" Pokorski 2013-03-12 21:45:44 UTC
Hi. I'd like to add that for me this is also happening for other windows, like IntelliJ IDEA splash screen or Veromix plasmoid volume sliders window (the one that pops out when you click the icon). 
And, of course,the "close window" buttons that were on "present windows", but I already turned these off. I prefer the middle mouse button anyway. KDE 4.8.
Comment 48 Bartłomiej Burdukiewicz 2013-03-14 01:35:22 UTC
Bug still present, Fade desktop is also affected (ghost window). Desktop Grid is unaffected.

I added video on youtube (file too big for bugtracker), http://www.youtube.com/watch?v=BTjXdGy1-qY
Comment 49 Thomas Lübking 2013-03-14 10:28:02 UTC
There's also the dolphin ghost, so this is NOT limited to the close buttons and by this all attempts can be counted as void, since the source is likely sth. different.

Please deactivate the fade effect and attempt to re-trigger this.
Comment 50 Bartłomiej Burdukiewicz 2013-03-14 15:39:16 UTC
I wrote about the ghost window issue (comment #35) before any of these patches appeared.
Comment 51 Cezar "ikari" Pokorski 2013-03-14 17:25:47 UTC
It should probably be noted that it always and only (at least, for me) happens to the "special" borderless windows (splash screens, popups from plasmoids, I guess even the "pager layout" preview from time to time).
Comment 52 Thomas Lübking 2013-03-14 18:37:58 UTC
How many activities do you use?
Comment 53 Bartłomiej Burdukiewicz 2013-03-14 18:51:34 UTC
One. Now I'm on pure 4.10.1 kwin with this patch http://wklej.org/id/981816/. Is there a way to disable activities for good?
Comment 54 Martin Flöser 2013-03-14 19:33:31 UTC
(In reply to comment #53)
> One. Now I'm on pure 4.10.1 kwin with this patch
> http://wklej.org/id/981816/. Is there a way to disable activities for good?
given that you mention a patch you are able to compile :-) In that case look at build option KWIN_BUILD_ACTIVITIES
Comment 55 Thomas Lübking 2013-03-14 19:46:03 UTC
It's however rather not the issue (one activity).
Have you tried disabling the fade effect?
Comment 56 Bartłomiej Burdukiewicz 2013-03-14 20:29:31 UTC
(In reply to comment #54)
> (In reply to comment #53)
> > One. Now I'm on pure 4.10.1 kwin with this patch
> > http://wklej.org/id/981816/. Is there a way to disable activities for good?
> given that you mention a patch you are able to compile :-) In that case look
> at build option KWIN_BUILD_ACTIVITIES

I'm working with portage and activities USE flag is missing :) I don't even try to check cmake build options and run cmake manually (in before no reason). But I'll create ebuild fork to do so.
Comment 57 Bartłomiej Burdukiewicz 2013-03-14 20:39:11 UTC
(In reply to comment #55)
> It's however rather not the issue (one activity).
> Have you tried disabling the fade effect?

Maybe I'm wrong, but the video that I uploaded contain only Desktop Cube Animation and Present Window (without fade). So I already did what you asked me to do.
Comment 58 Sebastian Zientek 2013-03-14 21:50:13 UTC
Created attachment 78082 [details]
Screenshot showing the bug

I'm using Chakra Linux 2013.03, Fresh installation and default configuration KDE 4.10.1, Qt4.8.4.

I have same odd behavior. In ma case (step by step).
1. Open window.
2. Minimize.
3. Trigger Present Window.
4. Close window.
5. Switch between desktop.
Comment 59 Bartłomiej Burdukiewicz 2013-03-14 21:59:42 UTC
I'm wondering that porting from Xlib to XCB may fix this eventually. Or uncover the main reason of this.
Comment 60 Thomas Lübking 2013-03-14 22:11:59 UTC
(In reply to comment #59)
> I'm wondering that porting from Xlib to XCB may fix this eventually. Or
> uncover the main reason of this.

hardly. also i've *never* seen this.
It just seems that unmanaged windows are prone to encounter this but managed windows can as well (see video)

Can somebody encountering this for sure please attach ~/.kde/share/kwinrc?
(Yes, there's one but that's from 2010)
Comment 61 Bartłomiej Burdukiewicz 2013-03-14 22:28:51 UTC
Created attachment 78084 [details]
Configuration of KWin (4.10.1)

Here is my configuration. Sorry I should do this before.
Comment 62 Bartłomiej Burdukiewicz 2013-03-14 22:53:51 UTC
(In reply to comment #60)
> hardly. also i've *never* seen this

Did you try check this on custom environment? My friend Sebastian have same issue with brand new installation. His hardware is way different than my. I'll do research with Chakra on my VirtualBox, if I find that bug, Is there any chance that you will try?
Comment 63 Thomas Lübking 2013-03-14 23:21:52 UTC
ok, does not seem to be sth. in the kwin configuration... (if it happens pretty much constantly)
Comment 64 Cezar "ikari" Pokorski 2013-03-15 07:55:25 UTC
(In reply to comment #60)

> hardly. also i've *never* seen this.

Fun fact is: I've seen it always,  ever since I switched from Gnome+Compiz to KDE and tried to have as much of my old Compiz setup as possible. I always thought it's known-but-unfixable... 
I've had this on Intel (with Optimus) and nVidia cards (as the only one), I'm almost sure it happened on my desktop (Intel only)  as well. It's hard to find anything common for these except,  I don't know,  Polish regional settings, Debian/Ubuntu distribution, and the user (myself)...
Comment 65 Martin Flöser 2013-03-15 08:12:45 UTC
On Friday 15 March 2013 07:55:25 you wrote:
> https://bugs.kde.org/show_bug.cgi?id=259640
> 
> --- Comment #64 from Cezar "ikari" Pokorski <kde@ikari.pl> ---
> (In reply to comment #60)
> 
> > hardly. also i've *never* seen this.
I saw it in the past but haven't seen it for quit some time. I was able to 
trigger it when a window closed while restarting compositing, but that issue 
got fixed some time ago.
Comment 66 David de Cos 2013-03-15 08:36:54 UTC
For anyone not being able to reproduce this bug, please try the following method. I've successfully reproduced it in two machines with different distros and kwin settings:

(See http://dl.dropbox.com/u/49436584/bug_cube_rotation.avi)
1. Enable the option to show the close window buttons in the Present Windows settings.
2. Have exactly two windows open.
3. Use the Present Windows effect (in the video, I go to the top left corner of the screen).
4. Close one of the windows by clicking on the button that appears on its top right corner.
5. Click on the remaining window.
6. Rotate the cube.
Comment 67 Bartłomiej Burdukiewicz 2013-03-15 13:34:46 UTC
(In reply to comment #63)
> ok, does not seem to be sth. in the kwin configuration... (if it happens
> pretty much constantly)

I successfully reproduced this bug with Chakra (without installation, live). I used different computer.

Image installation on usb disk:
dd if=/home/dev/image.iso of=/dev/sdx bs=4K(In reply to comment #63)
Comment 68 Bartłomiej Burdukiewicz 2013-03-15 15:24:20 UTC
Fedora 18 is also affected.
Comment 69 Bartłomiej Burdukiewicz 2013-03-15 15:30:01 UTC
Mint 14 KDE is also affected :) All distros that I tested are on x86_64.
Comment 70 Thomas Lübking 2013-03-15 15:42:03 UTC
(In reply to comment #66)
> For anyone not being able to reproduce this bug, please try the following
> method. 

Thanks. Together with Bartłomiej's config it's reproducible.
"We can fix what we can see" - i got a reputation to loose ;-)
Comment 71 Thomas Lübking 2013-03-15 16:29:26 UTC
Created attachment 78097 [details]
Toodeloo...

.... I CAN SEE YOU    >-)

I'd claim to be on a pretty good track anyway =)
Comment 72 Martin Flöser 2013-03-15 16:44:06 UTC
ooooooh
Comment 73 Bartłomiej Burdukiewicz 2013-03-15 17:01:54 UTC
Yeah! This patch works \o/! Thank you very much. You did great job!
Comment 74 Cezar "ikari" Pokorski 2013-03-16 09:02:41 UTC
Tanks! I'll just sit here and wait for it to hit Debian Testing now...
Comment 75 Martin Flöser 2013-03-16 10:13:39 UTC
On Saturday 16 March 2013 09:02:41 you wrote:
> Tanks! I'll just sit here and wait for it to hit Debian Testing now...
good joke  :-D Debian Testing includes 4.8 - this fix will only be provided for 
4.10 or later. So once testing is unfrozen and new upstream releases come in, 
that will be fixed. Given the current speed of solving release blocker bugs I 
wouldn't be surprised if 4.11 or 4.12 are released before testing is unfrozen.
Comment 76 Cezar "ikari" Pokorski 2013-03-16 11:58:26 UTC
(In reply to comment #75)
> Given the current speed of solving release blocker bugs I wouldn't 
> be surprised if 4.11 or 4.12 are released before testing is unfrozen.

Yeah... I neither feel advanced enough to compile any important part of my system myself, nor corageous enough to switch to debian unstable (guess that should be more up to date), even though http://raphaelhertzog.com/2010/12/20/5-reasons-why-debian-unstable-does-not-deserve-its-name/ (I still remember all those times when I didn't have X working after reboot ;))
Comment 77 Martin Flöser 2013-03-16 12:15:49 UTC
 > > Given the current speed of solving release blocker bugs I wouldn't
> > be surprised if 4.11 or 4.12 are released before testing is unfrozen.
> 
> Yeah... I neither feel advanced enough to compile any important part of my
> system myself, nor corageous enough to switch to debian unstable (guess that
> should be more up to date), even though
now we are totally off-topic ;-) Unstable is frozen together with testing. Only 
way to get newer versions is experimental, but that's not a complete release 
and doesn't contain kde-workspace. On the long run tanglu, which got announced 
this week might be a solution - at least I will consider switching to it as a 
base system.
Comment 78 Thomas Lübking 2013-03-20 21:19:16 UTC
Git commit 342f3a9ff2d9587601039605e42df873fa7b75a3 by Thomas Lübking.
Committed on 11/03/2013 at 16:19.
Pushed by luebking into branch 'KDE/4.10'.

keep + track m_closeWindow to keep m_winData alive
FIXED-IN: 4.10.2
REVIEW: 109509

M  +20   -6    kwin/effects/presentwindows/presentwindows.cpp

http://commits.kde.org/kde-workspace/342f3a9ff2d9587601039605e42df873fa7b75a3
Comment 79 Thomas Lübking 2013-03-20 21:24:37 UTC
Git commit 508a1da0becd739302ca28f5f1fb53967a0cfd93 by Thomas Lübking.
Committed on 11/03/2013 at 16:19.
Pushed by luebking into branch 'master'.

keep + track m_closeWindow to keep m_winData alive
FIXED-IN: 4.10.2
REVIEW: 109509

M  +20   -6    kwin/effects/presentwindows/presentwindows.cpp

http://commits.kde.org/kde-workspace/508a1da0becd739302ca28f5f1fb53967a0cfd93
Comment 80 Thomas Lübking 2013-05-06 15:00:41 UTC
*** Bug 319413 has been marked as a duplicate of this bug. ***